#include <iostream>
#include <bits/stdc++.h>

using namespace std;

#define en '\n'
#define ll long long
#define ld long double
vector<int> used;
vector<bool> pos;
vector<vector<ll>> g;
struct zxc {
    ll a, b;
};

void dfs(int v) {
    used[v] = 1;
    for (int u: g[v]) {
        if (!used[u]) {
            dfs(u);
        }
    }
}

ll cnt = 0;

void bfs(int v, vector<ll> d, ll h) {
    d[v] = 0;
    queue<int> q;
    q.push(v);
    while (!q.empty()) {
        v = q.front();
        q.pop();
        for (int u: g[v]) {
            if(min(d[u],d[v]+1)>h){
                return;
            }
            if (d[u] > d[v] + 1) {
                d[u] = d[v] + 1;
                q.push(u);
            }
            if (d[u] <= h) {
                if (!pos[u]) {
                    cnt++;
                    pos[u] = true;
                }
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    ll n, m, k;
    cin >> n >> m >> k;
    g.resize(n + 1);
    pos.resize(n + 1, false);
    vector<pair<ll, ll>> f(k);
    for (int i = 0; i < m; ++i) {
        ll a, b;
        cin >> a >> b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    for (int i = 0; i < k; ++i) {
        ll p, h;
        cin >> p >> h;
        f[i] = {p, h};
    }
    vector<ll> d(n+1, 1e18);
    for (int i = 0; i < k; ++i) {
        if (!pos[f[i].first]) {
            pos[f[i].first] = true;
            cnt++;
        }
        bfs(f[i].first, d, f[i].second);
    }
    cout << cnt << en;
    for (int i = 0; i < pos.size(); ++i) {
        if (pos[i]) {
            cout << i << " ";
        }
    }
    return 0;
}















